#include "particle.h"
#include "field.h"

int FieldLayer::Draw( )
{
	if (!Active)
		return 0; 
	int divisor = 15;
	Point_2d res = GetSceneGraph()->GetResolution();

	ParticleState s;
	s.charge = 1;
	
	if (Particles->GetTotalParticles() == 0)
		return 0;
	for (int y = 0; y <= res.y; y+= divisor)
	{
		for (int x = 0; x <= res.x; x+= divisor)
		{
			s.pos.x = x;
			s.pos.y = y;

			Point_2d force = Particles->CalcForce(&s);
		
			// draw arrow with color indicating magnitude
			// centered at x
			float strength = force.Magnitude();
			force.Normalize();
			force *= divisor;

			glBegin(GL_LINES);
			
			float blue;
			blue = strength*40;

			glColor3f(.2f,.2f,blue);
			glVertex3f(x - force.x/2,y-force.y/2, 0);	
			glVertex3f(force.x/2 + x, force.y/2 + y,0);
			// draw arrowhead at end

			// calc inverse slope and scale
			Point_2d invslope;
			invslope.x = -force.y/8;
			invslope.y = force.x/8;

			glVertex3f(invslope.x + x, invslope.y + y,0);
			glVertex3f(force.x/2 + x, force.y/2 + y,0);
			glVertex3f(-invslope.x + x, -invslope.y + y,0);
			glVertex3f(force.x/2 + x, force.y/2 + y,0);		
			glEnd();

		}

	}
	
	




	return 1;
}


void FieldLayer::SetActive( int active)
{ 
	Active = active; 
	if (Active)
		GetSceneGraph()->AddNote("Electric field visualization activated \nPlease note field is calculated as if charges were static",15);
}

