#ifndef FONTINCLUDED
#define FONTINCLUDED

#include <windows.h>
#include <gl/gl.h>
#include "point2d.h"

class Font
{
public:
	Font();
	~Font();

	void Draw( float startx, float starty, char* text, int lettercount);
	// returns text dimensions in pixels
	Point_2d GetSize( char* text, int lettercount);
		
	int GetLineHeight();	// returns line height in pixels

	// shows or hides text ( 1 = shows, 0 = hides)
	void ShowText(int option);
	
protected:
	int HideText;
	float DrawLetter( float x, float y, int index);
	void Setup( char first, char last);
	struct CharInfo
	{
		// two corners for box each letter takes up
		// these are in texture coordinates
		float top, left, right, bottom;
		float width;	// percent of block taken up by letter, whole block width is one
	};

	GLuint	Texture;
	CharInfo* Letters;	// pointer to letter offset infomation
	int LineHeight;
	int CharSpace;
	float Scale;	// how many pixels per texture unit
	int StartChar;	// first ascii character
	int EndChar;	// last ascii character
	int Total;	// total characters in set

};

void InitFont();
void ShutdownFont();
Font* GetFont();



#endif
