#ifndef GUILAYERINC
#define GUILAYERINC

#include <list>
#include "scenegraph.h"


// two utility functions
void DrawButton(float left, float top,
				float width, float height,
				char* text, 
				float innercolor[3], float outercolor[3] );
int IntersectButton( float checkx, float checky,
					 float top, float left,
					 float width, float height);

class GUIListener;
class MenuItem
{
public:
	void SetColor( int c) { ColorOption = c; }

// private:
	float x, y;
	int ColorOption;
	std::string Name;
	GUIListener *Listener;
};

class GUIListener
{
public:
	virtual int OnClick() = 0;
	MenuItem* GetControl() { return menu; }

//private:
	MenuItem* menu;
};


class GUILayer : public SceneLayer
{
public:
	GUILayer();
	// adds an option to the main menu
	void AddMenuOption( char* name);
	// removes menu category, mainly for after licensing
	void RemoveMenuOption( char* name);
	// adds an item to a menu option
	// parent is name of menu option
	void AddMenuItem( char* parent, char* name, GUIListener* listener, int startcolor);

	int OnMouse( int x, int y, int buttons[4], int buttonchange);
	int Draw( );
	void SetActive( int truefalse);
	int GetActive() { return Active; }
private:
	float BarHeight;
	float TabWidth;
	float SubMultiplier;
	int Active;
	int Offset;
	struct MenuOption
	{
		float x, y;
		std::string Name;
		std::list<MenuItem> Children;
	};

	// holds current active menu option, or null for none active
	MenuOption* CurrentOption;
	
	std::list< MenuOption> Options;
};


#endif