#include <stdlib.h>
#include <windows.h>
#include <string.h>
#include <io.h>
#include <time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "log.h"

#ifdef LOGTHEOUTPUT

int FileHandle = -1;

void InitLog( libIOStream* logstream)
{
	MessageBox(0, "InitLog( libIOStream* logstream) Not Yet Implemented", "Error", MB_OK);
}

void InitLog(char* filename)
{
	FileHandle = open(filename, _O_CREAT | _O_TRUNC | _O_RDWR | _O_TEXT, _S_IWRITE  );
	if (FileHandle==-1)
		return;
	
	// write out 
	char *message;
	message = "APPLICATION LOG START \n";
	write(FileHandle, message, strlen(message));
	write(FileHandle, "Time: ", strlen("Time: "));
	time_t curtime;
	time( &curtime );
	char* texttime = ctime( &curtime );
	write(FileHandle, texttime, strlen(texttime));

	LogMessageX("log initialized");
}

void ShutdownLog()
{
	if (FileHandle!=-1)
		close(FileHandle);

	LogMessageX("log shutdown");
}

// prints to the standard output
// can be set to console, file, screen
// however default implementation only prints to file

void LogMessage(char* msg)
{
	if (FileHandle==-1)
		return;
	write(FileHandle, msg, strlen(msg));
	write(FileHandle, "\n", 1);
	_commit(FileHandle);	// make sure file is commited, not just in buffer
}

void LogMessage(char* msg, char* file, int line)
{
	char number[256];
	itoa( line, number, 10);
	int length;
	length = strlen(number)+strlen(file)+strlen(msg) +strlen(" file: line:")+1;
	
	char* buffer = new char[length];

	strcpy( buffer, msg);;
	strcat( buffer, " file:");
	strcat( buffer, file);
	strcat( buffer, " line:");
	strcat( buffer, number);

	LogMessage(buffer);

	delete [] buffer;
}


#endif