#include "point2d.h"

double Point_2d::Distance(Point_2d& p1, Point_2d& p2)
{
	Point_2d diff = p1 - p2;
	return diff.Magnitude();
}

Point_2d::Point_2d()
{

}

Point_2d::Point_2d( double nx, double ny)
{
	x = nx;
	y = ny;
}

int Point_2d::operator==( Point_2d other)
{
	return (other.x == x) && (other.y == y);
}

double Point_2d::Magnitude()
{
	return double(sqrt((x*x)+(y*y)));
}

void Point_2d::Normalize()
{
	if ( (x*x + y*y) != 1.0f)
	{
		double length = Magnitude();
		x /= length;
		y /= length;
	}

}


Point_2d Point_2d::operator* (double scale)
{
	Point_2d ret;
	ret.x = x * scale;
	ret.y = y * scale;
	return ret;
}

Point_2d Point_2d::operator/ (double scale)
{
	Point_2d ret;
	ret.x = x / scale;
	ret.y = y / scale;
	return ret;
}

void Point_2d::operator*= (double scale)
{
	x = x * scale;
	y = y * scale;
}

void Point_2d::operator/= (double scale)
{
	x = x / scale;
	y = y / scale;
}

Point_2d Point_2d::operator- ( Point_2d other)
{
	Point_2d ret;
	ret.x = x - other.x;
	ret.y = y - other.y;
	return ret;
}

Point_2d Point_2d::operator+ ( Point_2d other)
{
	Point_2d ret;
	ret.x = x + other.x;
	ret.y = y + other.y;
	return ret;
}

void Point_2d::operator-= ( Point_2d other)
{
	x = x - other.x;
	y = y - other.y;
}

void Point_2d::operator+= ( Point_2d other)
{
	x = x + other.x;
	y = y + other.y;
}
